#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "comchk.h"
#include "rs232_dll.h"

/////////////////////////////////////////////////////////////////////
//   Variables
/////////////////////////////////////////////////////////////////////
int port = 0;

/////////////////////////////////////////////////////////////////////
//   Function Prototypes
/////////////////////////////////////////////////////////////////////
int vitec_test_init(void);
void vitec_test_close(void);
void vitec_test_measure(int *r1, int *r2, int *r3, int *r4, int *r5, int *r6);


/////////////////////////////////////////////////////////////////////
//   Functions
/////////////////////////////////////////////////////////////////////

int vitec_test_init(void)
{
	int n,r,baud;
	unsigned char buf[80];
	
	// open COM port
	port_device_scan();
	port_device_pickup_by_type(2); // FTDI
	n = get_how_many_port_devices();
	if (n==0) {
		return 1; // not found
	} else {
		port = get_port_number(0); // port# of 1st device
	}
	baud = 9600;
	r=rs_open(port,baud);
	if (r==-1) {
		return 2; // cannot open
	}
	
	// 
	rs_puts(port,(unsigned char *)"0F\r\n"); // Initial reset command
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
	Sleep(250);
	
	rs_puts(port,(unsigned char *)"050027950000\r\n"); // setting1
	rs_gets(port,(unsigned char *)buf); rs_getch(port);

	rs_puts(port,(unsigned char *)"0DF3\r\n"); // setting2
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
	
	rs_puts(port,(unsigned char *)"27\r\n"); // sensor Set/Reset in next measure
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
	
	rs_puts(port,(unsigned char *)"21\r\n"); // Measure  with Set/Reset
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
	
	Sleep(100);
	return 0;
}

void vitec_test_close(void)
{
	if (port>0) { rs_close(port); }
	return;
}

void vitec_test_measure(int *d1, int *d2, int *d3, int *d4, int *d5, int *d6)
{
	unsigned char buf[80]; 
	int a;
	int r1,r2,r3,r4,r5,r6;
	
	// OvR}hł̌vʂ̃f[^ǂݏo
	rs_puts(port,(unsigned char *)"29\r\n"); // Read measured data
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
	
	//M񂩂f[^o
	sscanf((char *)buf,"%04x%04x%04x%04x%04x%04x",&r1,&r2,&r3,&r4,&r5,&r6);
	
	if (r1>0x8000) { r1= r1 - 0x10000; }
	if (r2>0x8000) { r2= r2 - 0x10000; }
	if (r3>0x8000) { r3= r3 - 0x10000; }
	if (r4>0x8000) { r4= r4 - 0x10000; }
	if (r5>0x8000) { r5= r5 - 0x10000; }
	if (r6>0x8000) { r6= r6 - 0x10000; }
	
	r4*=10; r5*=10; r6*=10; // xZTl10{
	
	*d1 = r2;  // CZT  xy
	*d2 = r1;  //  "
	*d3 = r3;
	
	*d4 = r5;  // xZT  xy
	*d5 = r4;  //  "
	*d6 = r6;
	
	// ̌vX^[g
	rs_puts(port,(unsigned char *)"21\r\n"); // Measure
	rs_gets(port,(unsigned char *)buf); rs_getch(port);
}
